//----------------------------------------------------------------------------------------
// IUnit.h
//----------------------------------------------------------------------------------------
// Defines a new Unit structure that adds extra capabilities to the Units
//
// Eddy productions 2004/2005
//----------------------------------------------------------------------------------------

#ifndef IUnit_H
#define IUnit_H


#include "Outpost2DLL.h"
#include "commands.h"

class __declspec(dllexport) IUnit : public Unit
{
public:
	IUnit();
	enum map_id GetCargo() { return Unit::GetCargo(); }

// New functions (some functions can only be done by a certain unit type):
public:
	void Doze(MAP_RECT region);		// use with RoboDozer only
	void Dock();							// to be used when a unit in on a docking pad
	void DockGarage();					// to be used when a unit in on a docking pad of a garage
	void Build(LOCATION location);	// use when there's a kit inside a convec, or when this is a miner/geocon
	void Produce(enum map_id itemToProduce,enum map_id weaponType);
	void TransferCargo(short bay);	// to be used when a unit in on a docking pad
	void LoadCargo();						// to be used when a unit in on a docking pad
	void UnloadCargo();					// to be used when a unit in on a docking pad
	void DumpCargo();
	void Research(short techID,short numScientists);	// use only with labs
	void TrainScientists(short numTrained);				// use only with university
	void Salvage(MAP_RECT region,IUnit gorf);
	void Poof();
	void Repair(IUnit target);			// use with convec or repait vehicle
	void Reprogram(IUnit target);		// use with spider only
	void Dismantle(IUnit target);		// use with convec

	command_type GetBusy();				// returns what this unit is doing (0=not busy)
	void GetFactoryCargo(int bay, enum map_id &unitType, enum map_id &weaponType);
	void GetCargo(map_id &cargoType,map_id &weaponType);	// works for convecs
	int GetTruckCargo(Truck_Cargo &cargoType);				// returns amount of cargo
	int GetDamage();						// 0=no damage

	bool IsInRect(MAP_RECT rect);		// returns true if the unit is in the rect
};


class __declspec(dllimport) IUnit;


#endif	// IUnit_H
